import os,sys
import subprocess
import yaml

def cmd_live(cmd,log):
    process = subprocess.Popen([cmd],stdout=subprocess.PIPE,stderr=subprocess.PIPE,shell=True,text=True)    
    while True:
        op=process.stdout.readline().strip()               
        if process.poll() is not None:
            break
        if op:
            log(op)             
    rc = process.poll()
    return rc

def cmd_run(cmd,log):
    op = subprocess.Popen([cmd],stdout=subprocess.PIPE,stderr=subprocess.PIPE,shell=True,text=True)
    res=op.communicate()    
    res = list(filter(None, res))
    final=list()   
    for i in res:
        x=i.split('\n')
        for q in x:
            final.append(q)    
    for p in final:
        log(p)
    return op.returncode

def cmd_runandreturn(cmd):
    try:
        op = subprocess.Popen([cmd],stdout=subprocess.PIPE,stderr=subprocess.PIPE,shell=True,text=True)
        res=op.communicate()    
        res = list(filter(None, res))
        final=list()   
        for i in res:
            x=i.split('\n')
            for q in x:
                final.append(q) 
        final = list(filter(None, final))
    except :
        final=list()
    return final

def readplain(dfile):
    if os.path.isfile(dfile):
        data=list()
        try:
            pre=[]
            with open(dfile,'r') as f:
                lines=f.readlines()
            for l in lines:
                d=l.strip()
                pre.append(d)
            data=list(dict.fromkeys(pre))
        except Exception as e :            
            data=[]
    else:
        data=list()    
    return data  

def get_os(osfile):
    data=readplain(osfile)
    fdata={}
    if bool(data):
        for d in data:
            x=d.split('=')
            fdata[x[0]]=x[1]
    return fdata


def readyaml(datafile): 
    if os.path.isfile(datafile):  
        with open(datafile, 'r') as stream:
            try:
                data_loaded = yaml.load(stream, Loader=yaml.FullLoader)
            except ValueError as e:                
                data_loaded={}
    else:
        data_loaded={}  
    return data_loaded

def writeyaml(datafile,data):   
    status=False
    with open(datafile, 'w', encoding='utf8') as outfile:
        try:
            yaml.dump(data,outfile,sort_keys=True,default_flow_style=False)            
            status=True
        except ValueError as e:
            print(str(e))
            status=False
    return status