import os
import sys
import logging
import pwd

formatter = logging.Formatter('[%(asctime)s +%(msecs)04d] - %(name)s - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')
cformatter = logging.Formatter('[%(asctime)s +%(msecs)04d] - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')
uformatter = logging.Formatter('[%(asctime)s +%(msecs)04d] - %(message)s',datefmt='%Y-%m-%d %H:%M:%S')

def get_console_handler():
    console_handler = logging.StreamHandler(sys.stdout)
    console_handler.setFormatter(cformatter)
    return console_handler

def get_file_handler(logfile):    
    logpath='/var/log/'+logfile    
    file_handler =logging.FileHandler(logpath)
    file_handler.setFormatter(formatter)
    return file_handler

def get_logger(logfile):
    logger= logging.getLogger()
    logger.setLevel(logging.INFO)
    if sys.stdin.isatty():
        logger.addHandler(get_console_handler())
    logger.addHandler(get_file_handler(logfile))
    logger.propagate = False
    return logger
