import os,sys
from pprint import pprint
from . import sloger,common,ubuntuinstall,rhelinstall
from .shellcolor import scolor
from datetime import datetime

def finalize(log):
    log("Eesnos installation has been completed.")
    print("=====================================================================\n\n\n")
    print("You can login to the WAP portal using the following quick login link\n\n")
    os.system('/usr/local/eenos/scripts/quicklogin -r')
    print("\nSetup disk quotas using : /usr/local/eenos/scripts/setupquota ")
    print("\n\n=====================================================================")
    print("Thank you for installing Eenos High Performance Hosting Control Panel")

def start(os_data,configure):    
    start_time = datetime.now()
    logfile='install-eenos.log'
    logger=sloger.get_logger(logfile)
    log=logger.info
    log("Starting eenos installation. Installation log file is : %s/var/log/%s%s " %(scolor.blue,logfile,scolor.end))
    if os_data['os']=='Ubuntu':
        ubuntuinstall.start_ubuntu_install(os_data,configure,log)    
    if os_data['os']=='RHEL':
        rhelinstall.start_rhel_install(os_data,configure,log)  
    finalize(log)
    end_time = datetime.now()
    print('Total Installation Time Spend : {}'.format(end_time - start_time))
    for handler in logger.handlers:
        handler.close()
    logger.handlers.clear()